<?php

namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\Controller\CrudWithParameterBag;
use Zeedhi\Framework\DTO;
use Teknisa\MAN\Utilities;
use Teknisa\MAN\Services\RelatorioService;
use Teknisa\MAN\Services\RelVendasProdutoPeriodoporModo as RelService;
use Zeedhi\Framework\DataSource\DataSet;

class RelVendasProdutoPeriodoporModo extends CrudWithParameterBag{
    
    const RELATORIO_POR_DIA_NAME = 'vnd55008_relVendasProdutoPeriodoporModo';
    
    public function __construct (Utilities\Util $utilService, RelatorioService $relatorioService, RelService $relService) {
      
        $this->utilService = $utilService;
        $this->relatorioService = $relatorioService;
        $this->relService = $relService;
    }
    
    public function find(DTO\Request\Filter $request, DTO\Response $response){
        ini_set('memory_limit', '1G');
        set_time_limit(120);
        $conditions = $this->utilService->getParamsAsArray($request);
        $conditions = $this->relService->buildParamsForRel($conditions);
        
        if(isset($conditions['TIMEINI']) && isset($conditions['TIMEFIM']) && isset($conditions['TIPORELATORIO']) && $conditions['DTINI'] && $conditions['DTFIM']){
            $result = $this->relService->findVendasProdMod($conditions);
        }else{
            $result = array();
        }
        
        $response->addDataSet(new DataSet(SELF::RELATORIO_POR_DIA_NAME, $result));
        return $response;
    }
}
