<?php

namespace Teknisa\MAN\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\MAN\Utilities;

class LogsCreditoNoCashService {
    
	public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
	}

    
    public function fetchLogs($conditions) {
    	$params = array (
            ':DTINI' => $conditions['DTOPERACAO'][0], 
            ':DTFIN' => $conditions['DTOPERACAO'][1],
            ':CDCLIENTE'    => $conditions['CDCLIENTE'],
            ':CDCONSUMIDOR' => $conditions['CDCONSUMIDOR'],
            ':CDTPOPERACAO'  => array_key_exists('CDTPOPERACAO', $conditions) ? $conditions['CDTPOPERACAO'] : 'T'
        );
        
        return $this->entityManager->getConnection()->fetchAll(self::SELECT_LOGS, $params);
        
    }



    const SELECT_LOGS = "
        SELECT LG.CDCLIENTE, LG.CDCONSUMIDOR, TO_CHAR(LG.DTOPERACAO, 'DD/MM/YYYY') as DATAOPERACAO, LG.DTOPERACAO, CL.NMRAZSOCCLIE, LG.DSLOGCREDCONS AS DSCREDCONSUMIDOR, 
        CASE CDTPOPERACAO WHEN '1' THEN 'Criação' WHEN '2' THEN 'Alteração' END AS CDTPOPERACAO, CO.CDCONSUMIDOR, CO.NMCONSUMIDOR,
        TO_CHAR(LG.DTOPERACAO, 'HH24:MM:SS') as HORAOPERACAO
        FROM LOGCREDCONSUMIDOR LG 
        JOIN CLIENTE CL ON
            LG.CDCLIENTE = CL.CDCLIENTE
        JOIN CONSUMIDOR CO ON
            LG.CDCONSUMIDOR = CO.CDCONSUMIDOR AND
            LG.CDCLIENTE = CO.CDCLIENTE
        WHERE TO_CHAR(LG.DTOPERACAO, 'DD/MM/YYYY') BETWEEN TO_DATE(:DTINI, 'DD/MM/YYYY') AND TO_DATE(:DTFIN, 'DD/MM/YYYY')
        AND LG.CDCLIENTE = :CDCLIENTE
        AND LG.CDCONSUMIDOR = :CDCONSUMIDOR
        AND (LG.CDTPOPERACAO = :CDTPOPERACAO OR 'T' = :CDTPOPERACAO)
        ORDER BY  HORAOPERACAO, CDTPOPERACAO, DATAOPERACAO
            
    ";
}